Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS.m	(revision 623)
@@ -1,99 +1,91 @@
-%ZIS	;SFISC/AC,RWF -- DEVICE HANDLER ;1/24/08  16:06
-	;;8.0;KERNEL;**18,23,69,112,199,191,275,363,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-	N %ZISOS,%ZISV
-	S U="^",%ZISOS=$G(^%ZOSF("OS")),%ZISV=$G(^%ZOSF("VOL"))
-	;Check SPOOLER special case first
-INIT	I $D(ZTQUEUED),$G(IOT)="SPL",$D(IO)#2,$D(IO(0))#2,IO]"",IO=IO(0),$D(IO(1,IO))#2,%ZISOS["VAX DSM"!(%ZISOS["M/VX"),$G(IOP)[ION!(IOP[IO) K %ZIS,%IS,IOP Q
-	;
-	I '$D(%ZIS),$D(%IS) M %ZIS=%IS
-	S:'($D(%ZIS)#2) %ZIS="M" M %IS=%ZIS ;update %IS for now
-	I '$D(^XUTL("XQ",$J,"MIXED OS")) S ^XUTL("XQ",$J,"MIXED OS")=$$PRI^%ZOSV
-	S %ZIS("PRI")=$G(^XUTL("XQ",$J,"MIXED OS"),1)
-	;
-	I $D(ZTQUEUED) D  I '$D(IOP) S POP=1 G EXIT^%ZIS1
-	.I $D(ZTIO)#2,ZTIO="" S:%IS'[0 %IS=%IS_"0",%ZIS=%ZIS_"0"
-	I '$D(ZTQUEUED),%IS["T",$P($G(IOP),";")="Q" S POP=1 G EXIT^%ZIS1
-	N %,%A,%E,%H,%I,%X,%XX,%Y,%Z,%Z1,%Z2,%Z9,%Z90,%Z91,%Z95,%ZISB,%ZTIME,%ZTYPE
-	N %ZHFN,%ZISOLD,DTOUT,DUOUT
-	;Save symbols to restore if don't open a device
-	D SYMBOL^%ZISUTL(0,$NA(%ZISOLD))
-A	D CLEAN ;(p363) K IO("CLOSE"),IO("HFSIO")
-	K IO("P"),IO("Q"),IO("S"),IO("T")
-K2	D K2^%ZIS1
-	S %ZISB=%ZIS'["N",(%E,%H,POP)=0,%Y="" S:'$D(IO(0)) IO(0)=$I
-	I %ZISOS["VAX DSM",$I["SYS$INPUT:.;" S:%ZIS'[0 %IS=%IS_"0",%ZIS=%ZIS_"0"
-	;I %IS["T"&(%IS["0") S (%H,%E)=0 G ^%ZIS1
-	I $D(IOP),IOP=$I!(IOP="HOME")!(0[IOP),$D(^XUTL("XQ",$J,"IO")) D HOME K %IS,%Y,%ZIS,%ZISB,%ZISV,IOP Q
-	;Don't worry about HOME if %ZIS[0
-	D:%ZIS'[0 GETHOME G EXIT^%ZIS1:POP,^%ZIS1 ;Jump to next part
-	;
-GETHOME	I $D(IO("HOME")),$P(IO("HOME"),"^",2)=IO(0) S (%E,%H)=+IO("HOME") Q
-	I $D(^XUTL("XQ",$J,"IOS")),$D(^("IO")),IO(0)=^("IO") S (%E,%H)=^("IOS") Q
-	;CALL LINEPORT CODE HERE---
-	S %=$$LINEPORT^%ZISUTL I % S (%E,%H)=% Q
-	S %ZISVT=$I D VTLKUP I '%E S %ZISVT=$I D VIRTUAL
-	I %ZISVT=""!(%E'>0) I %IS'[0 O IO(0)::0 I $T U IO(0) W !,"HOME DEVICE ("_$I_") DOES NOT EXIST IN THE DEVICE FILE",!,"PLEASE CONTACT YOUR SYSTEM MANAGER!",*7
-	S %H=%E S:'%H&(%IS'[0) POP=1 S:(%H>0)&('$D(IO("HOME"))) IO("HOME")=%H_"^"_$I
-	Q
-VIRTUAL	;See if a Virtual Terminal (LAT, TELNET)
-	;Change the MSM check for telnet to work with v4.4
-	I %ZISOS["MSM" X "I $P($ZV,""Version "",2)'<3 S %ZISVT=$ZDE(+%ZISVT) I %ZISVT?.E1""~""4.5N.E S %ZISVT=""TELNET"""
-	F %ZISI=$L(%ZISVT):-1:0 D:$D(^%ZIS(1,"C",%ZISVT))  Q:$S('%E:0,'$D(^%ZIS(1,%E,"TYPE")):0,^("TYPE")="VTRM":1,1:0)  S %ZISVT=$E(%ZISVT,1,%ZISI)
-	.D VTLKUP Q:$S('%E:0,'$D(^%ZIS(1,%E,"TYPE")):0,^("TYPE")="VTRM":1,1:0)
-	.S %X=0 F %ZISX=%ZISV,"" Q:%X>0  S %X=0 F  S %E=+$O(^%ZIS(1,"CPU",%ZISX_"."_%ZISVT,%X)) S %X=%E Q:%E'>0  I $G(^%ZIS(1,+%E,"TYPE"))="VTRM" Q
-	Q
-VTLKUP	F %ZISX=%ZISV,"" S %E=+$O(^%ZIS(1,"G","SYS."_%ZISX_"."_%ZISVT,0)) Q:%E  S %E=+$O(^%ZIS(1,"CPU",%ZISX_"."_%ZISVT,0)) Q:%E
-	Q
-	;
-CURRENT	N POP,%ZIS,%IS,%E,%H
-	S FF="#",SL=24,BS="*8",RM=80,(SUB,XY)="",%IS=0,%ZISOS=$G(^%ZOSF("OS")),%ZISV=$G(^("VOL")),POP=0
-	D GETHOME K %E,%IS,%ZISI,%ZISOS,%ZISV,%ZISVT,%ZISX Q:POP
-	I $D(^%ZIS(1,%H,"SUBTYPE")) S SUB=+^("SUBTYPE") K %H
-	I $D(SUB),SUB,$D(^%ZIS(2,SUB,1)) S SUB=$S($D(^(0)):$P(^(0),"^"),1:""),FF=$P(^(1),"^",2),SL=$P(^(1),"^",3),BS=$P(^(1),"^",4),XY=$P(^(1),"^",5),RM=+^(1)
-	E  S SUB=""
-	I $D(^%ZOSF("RM")) N X S X=RM X ^("RM") K %A
-	Q
-HOME	;Entry point to establish IO* variables for home device.
-	D CLEAN ;(p363)
-	N X I '$D(^XUTL("XQ",$J,"IO")) S IOP="HOME" D ^%ZIS Q
-	D RESETVAR
-	I '$D(IO("C")),$G(IOM),IO=$I,$D(IO(1,IO)),$D(^%ZOSF("RM")) S X=+IOM X ^("RM")
-	Q
-	;IO("Q") is checked by many routines after a call to ^%ZISC, so only clean on call to %ZIS.
-CLEAN	;Cleanup env. Called from %ZISC also.
-	I $G(IOT)'="SPL" K IO("DOC"),IO("SPOOL") ;(p446)
-	I $G(IOT)'="HFS" K IO("HFSIO") ;p446
-	S (IOPAR,IOUPAR)=""
-	Q
-	;
-RESETVAR	;Reset home IO* variables.
-	I '$D(^XUTL("XQ",$J,"IO")) Q
-	N %
-	F %="IO","IOBS","IOF","IOM","ION","IOS","IOSL","IOST","IOST(0)","IOT","IOXY","IOPAR","IOUPAR" I $D(^XUTL("XQ",$J,%))#2 S @%=^(%)
-	F %="IO(""IP"")","IO(""CLNM"")","IO(""DOC"")","IO(""HFSIO"")","IO(""SPOOL"")" I $D(^XUTL("XQ",$J,%))#2 S @%=^(%)
-	S POP=0,IO(0)=IO
-	Q
-SAVEVAR	;Save home IO* variables, called from XUS1,%ZTMS3
-	N %
-	F %="IO","IOBS","IOF","IOM","ION","IOS","IOSL","IOST","IOST(0)","IOT","IOXY","IOPAR","IOUPAR" I $D(@%) S ^XUTL("XQ",$J,%)=@%
-	F %="IO(""IP"")","IO(""CLNM"")","IO(""DOC"")","IO(""HFSIO"")","IO(""SPOOL"")" I $D(@%) S ^XUTL("XQ",$J,%)=@%
-	Q
-ZISLPC	Q  ;No longer called in Kernel v8.
-	;
-HLP1	G EN1^%ZIS7
-HLP2	N %E,%H,%X,%ZISV,X S %ZISV=$S($D(^%ZOSF("VOL")):^("VOL"),1:"") G EN2^%ZIS7
-	;
-REWIND(IO2,IOT,IOPAR)	;Rewind Device
-	N %,X,Y,$ES,$ET S $ET="D REWERR^%ZIS Q 0"
-	S %=$I
-	I '($D(IO2)#2)!'$D(IOT)!'$D(IOPAR) Q 0
-	I "MT^SDP^HFS"'[IOT Q 0
-	S @("Y=$$REW"_IOT_"^%ZIS4(IO2,IOPAR)")
-	U %
-	Q Y
-REWERR	;Error encountered
-	S IO("ERROR")=$EC
-	S $EC="",$ET="Q:$ES>1  S $EC="""" Q 0" S $EC=",U1,"
-	Q 0
-	;
+%ZIS ;SFISC/AC,RWF -- DEVICE HANDLER ;10/14/2004  08:46
+ ;;8.0;KERNEL;**18,23,69,112,199,191,275,363**;JUL 10, 1995
+ N %ZISOS,%ZISV
+ S U="^",%ZISOS=$G(^%ZOSF("OS")),%ZISV=$G(^%ZOSF("VOL"))
+ ;Check SPOOLER special case first
+INIT I $D(ZTQUEUED),$G(IOT)="SPL",$D(IO)#2,$D(IO(0))#2,IO]"",IO=IO(0),$D(IO(1,IO))#2,%ZISOS["VAX DSM"!(%ZISOS["M/VX"),$G(IOP)[ION!(IOP[IO) K %ZIS,%IS,IOP Q
+ ;
+ I '$D(%ZIS),$D(%IS) M %ZIS=%IS
+ S:'($D(%ZIS)#2) %ZIS="M" M %IS=%ZIS ;update %IS for now
+ ;
+ I $D(ZTQUEUED) D  I '$D(IOP) S POP=1 G EXIT^%ZIS1
+ .I $D(ZTIO)#2,ZTIO="" S:%IS'[0 %IS=%IS_"0",%ZIS=%ZIS_"0"
+ I '$D(ZTQUEUED),%IS["T",$P($G(IOP),";")="Q" S POP=1 G EXIT^%ZIS1
+ N %,%A,%E,%H,%I,%X,%XX,%Y,%Z,%Z1,%Z9,%Z90,%Z91,%Z95,%ZISB,%ZTIME,%ZTYPE
+ N %ZHFN,%ZISOLD,DTOUT,DUOUT
+ ;Save symbols to restore if don't open a device
+ D SYMBOL^%ZISUTL(0,$NA(%ZISOLD))
+A D CLEAN ;(p363) K IO("CLOSE"),IO("HFSIO")
+ K IO("P"),IO("Q"),IO("S"),IO("T")
+K2 D K2^%ZIS1
+ S %ZISB=%ZIS'["N",(%E,%H,POP)=0,%Y="" S:'$D(IO(0)) IO(0)=$I
+ I %ZISOS["VAX DSM",$I["SYS$INPUT:.;" S:%ZIS'[0 %IS=%IS_"0",%ZIS=%ZIS_"0"
+ ;I %IS["T"&(%IS["0") S (%H,%E)=0 G ^%ZIS1
+ I $D(IOP),IOP=$I!(IOP="HOME")!(0[IOP),$D(^XUTL("XQ",$J,"IO")) D HOME K %IS,%Y,%ZIS,%ZISB,%ZISV,IOP Q
+ ;Don't worry about HOME if %ZIS[0
+ D:%ZIS'[0 GETHOME G EXIT^%ZIS1:POP,^%ZIS1 ;Jump to next part
+ ;
+GETHOME I $D(IO("HOME")),$P(IO("HOME"),"^",2)=IO(0) S (%E,%H)=+IO("HOME") Q
+ I $D(^XUTL("XQ",$J,"IOS")),$D(^("IO")),IO(0)=^("IO") S (%E,%H)=^("IOS") Q
+ ;CALL LINEPORT CODE HERE---
+ S %=$$LINEPORT^%ZISUTL I % S (%E,%H)=% Q
+ S %ZISVT=$I D VTLKUP I '%E S %ZISVT=$I D VIRTUAL
+ I %ZISVT=""!(%E'>0) I %IS'[0 O IO(0)::0 I $T U IO(0) W !,"HOME DEVICE DOES NOT EXIST IN THE DEVICE FILE",!,"PLEASE CONTACT YOUR SYSTEM MANAGER!",*7
+ S %H=%E S:'%H&(%IS'[0) POP=1 S:(%H>0)&('$D(IO("HOME"))) IO("HOME")=%H_"^"_$I
+ Q
+VIRTUAL ;See if a Virtual Terminal (LAT, TELNET)
+ ;Change the MSM check for telnet to work with v4.4
+ I %ZISOS["MSM" X "I $P($ZV,""Version "",2)'<3 S %ZISVT=$ZDE(+%ZISVT) I %ZISVT?.E1""~""4.5N.E S %ZISVT=""TELNET"""
+ F %ZISI=$L(%ZISVT):-1:0 D:$D(^%ZIS(1,"C",%ZISVT))  Q:$S('%E:0,'$D(^%ZIS(1,%E,"TYPE")):0,^("TYPE")="VTRM":1,1:0)  S %ZISVT=$E(%ZISVT,1,%ZISI)
+ .D VTLKUP Q:$S('%E:0,'$D(^%ZIS(1,%E,"TYPE")):0,^("TYPE")="VTRM":1,1:0)
+ .S %X=0 F %ZISX=%ZISV,"" Q:%X>0  S %X=0 F  S %E=+$O(^%ZIS(1,"CPU",%ZISX_"."_%ZISVT,%X)) S %X=%E Q:%E'>0  I $G(^%ZIS(1,+%E,"TYPE"))="VTRM" Q
+ Q
+VTLKUP F %ZISX=%ZISV,"" S %E=+$O(^%ZIS(1,"G","SYS."_%ZISX_"."_%ZISVT,0)) Q:%E  S %E=+$O(^%ZIS(1,"CPU",%ZISX_"."_%ZISVT,0)) Q:%E
+ Q
+ ;
+CURRENT N POP,%ZIS,%IS,%E,%H
+ S FF="#",SL=24,BS="*8",RM=80,(SUB,XY)="",%IS=0,%ZISOS=$G(^%ZOSF("OS")),%ZISV=$G(^("VOL")),POP=0
+ D GETHOME K %E,%IS,%ZISI,%ZISOS,%ZISV,%ZISVT,%ZISX Q:POP
+ I $D(^%ZIS(1,%H,"SUBTYPE")) S SUB=+^("SUBTYPE") K %H
+ I $D(SUB),SUB,$D(^%ZIS(2,SUB,1)) S SUB=$S($D(^(0)):$P(^(0),"^"),1:""),FF=$P(^(1),"^",2),SL=$P(^(1),"^",3),BS=$P(^(1),"^",4),XY=$P(^(1),"^",5),RM=+^(1)
+ E  S SUB=""
+ I $D(^%ZOSF("RM")) N X S X=RM X ^("RM") K %A
+ Q
+HOME ;Entry point to establish IO* variables for home device.
+ D CLEAN ;(p363)
+ N X I '$D(^XUTL("XQ",$J,"IO")) S IOP="HOME" D ^%ZIS Q
+ D RESETVAR
+ I '$D(IO("C")),$G(IOM),IO=$I,$D(IO(1,IO)),$D(^%ZOSF("RM")) S X=+IOM X ^("RM")
+ Q
+ ;IO("Q") is checked by many routines after a call to ^%ZISC, so only clean on call to %ZIS.
+CLEAN ;Cleanup env. Called from %ZISC also.
+ K IO("DOC"),IO("HFSIO"),IO("SPOOL") ;(p366)
+ S (IOPAR,IOUPAR)=""
+ Q
+ ;
+RESETVAR ;Reset home IO* variables.
+ I '$D(^XUTL("XQ",$J,"IO")) Q
+ N % F %="IO","IOBS","IOF","IOM","ION","IOS","IOSL","IOST","IOST(0)","IOT","IOXY" I $D(^XUTL("XQ",$J,%))#2 S @%=^(%)
+ S POP=0,IO(0)=IO,(IOPAR,IOUPAR)=""
+ Q
+SAVEVAR ;Save home IO* variables, called from XUS1
+ N % F %="IO","IOBS","IOF","IOM","ION","IOS","IOSL","IOST","IOST(0)","IOT","IOXY" I $D(@%) S ^XUTL("XQ",$J,%)=@%
+ Q
+ZISLPC Q  ;No longer called in Kernel v8.
+ ;
+HLP1 G EN1^%ZIS7
+HLP2 N %E,%H,%X,%ZISV,X S %ZISV=$S($D(^%ZOSF("VOL")):^("VOL"),1:"") G EN2^%ZIS7
+ ;
+REWIND(IO2,IOT,IOPAR) ;Rewind Device
+ N %,X,Y,$ES,$ET S $ET="D REWERR^%ZIS Q 0"
+ S %=$I
+ I '($D(IO2)#2)!'$D(IOT)!'$D(IOPAR) Q 0
+ I "MT^SDP^HFS"'[IOT Q 0
+ S @("Y=$$REW"_IOT_"^%ZIS4(IO2,IOPAR)")
+ U %
+ Q Y
+REWERR ;Error encountered
+ S IO("ERROR")=$EC
+ S $EC="",$ET="Q:$ES>1  S $EC="""" Q 0" S $EC=",U1,"
+ Q 0
+ ;
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS1.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS1.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS1.m	(revision 623)
@@ -1,102 +1,93 @@
-%ZIS1	;SFISC/AC,RWF -- DEVICE HANDLER (DEVICE INPUT) ;1/24/08  16:06
-	;;8.0;KERNEL;**18,49,69,104,112,199,391,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-MAIN	;Called from %ZIS with a GO
-	I '$D(IOP),$D(^%ZIS(1,%E,0)),'$P(^(0),"^",3) S %A=%H,%Z=^(0) D L2^%ZIS2 G EXIT
-L1	;Main Loop
-	I '$D(IOP),$D(IO("Q")),POP D AQUE^%ZIS3 K:%=2 IO("Q") S:%=2 %ZISB=$S(%IS'["N":2,1:0) I %=-1 S POP=1 G EXIT
-	S %E=%H,POP=0,%IS=%ZIS ;Reset %IS from %ZIS
-	I %IS'["Q",$D(XQNOGO) S POP=1 W:'$D(IOP) !,$C(7),"OUTPUT IS NEVER ALLOWED FOR THIS OPTION" G EXIT
-	D IOP:$D(IOP),R:'$D(IOP)
-	G EXIT:$D(DTOUT)!$D(DUOUT)!(POP&$D(IOP)),L1:POP&'$D(IOP)
-	D LKUP I %A'>0 S POP=1 D:'$D(DUOUT) MSG1 K DUOUT
-	I '$D(^%ZIS(1,%A,0)) D MSG1 K %ZISIOS S POP=1
-	I POP G EXIT:$D(IOP),L1:'$D(IOP)
-	S %E=%A,%Z=^%ZIS(1,%A,0),%Z1=$G(^(1))
-	I $D(%ZIS("S")) N Y S Y=%E D XS^ZISX S:'$T POP=1 G G:POP
-	W:'$D(IOP)&($P(%Z,"^",2)'=$I)&($P(%Z1,"^")]"") "  ",$P(%Z1,"^")
-	D L2^%ZIS2 ;Call
-G	G L1:POP&'$D(IOP)&'($D(DTOUT)!$D(DUOUT)) ;Didn't get it
-	;
-EXIT	;
-	I POP G EX2 ;Did not get the device.
-	;For type[TRM reset $X & $Y
-	I %ZTYPE["TRM",IO]"",$D(IO(1,IO)) U IO S:'(IO=IO(0)&'$D(IO("S"))&'$D(ZTQUEUED)) $X=0,$Y=0
-	;Do count of number of times device opened.  Field 51.
-	I $L($G(IO)),$D(IO(1,IO))#2,$G(%ZISIOS) D
-	. S $P(^(5),"^",1)=$P($G(^%ZIS(1,%ZISIOS,5)),"^",1)+1
-	I %ZIS["H" S IO(0)=IO,IO("HOME")=%ZISIOS_"^"_IO ;Make home device
-	I '$D(IO("Q")),$D(%ZISLOCK) S ^XUTL("XQ",$J,"lock",%ZISIOS)=%ZISLOCK
-	I $D(IO)#2,IO]"",$D(IO(1,IO))#2,$D(%Z1),$P(%Z1,"^",11) S IO(1,IO,"NOFF")=1
-EX2	;
-	I %IS'[0,$G(IO(0))]"" U IO(0) ;Make sure return with home active
-	G SETVAR:'POP!(%IS["T"),KILVAR
-	;
-IOP	;Request with IOP set
-	S (%ZISVT,%X)=IOP S:%X'?1.UNP %X=$$UP(%X) I %X'="Q" D SETQ Q
-	S %IS=%IS_%X K IOP W %X D SETQ Q
-	;Get ready to ask user for device
-R	I %IS["Q",$D(XQNOGO) W !,$C(7),"AT THIS TIME, OUTPUT MUST BE QUEUED"
-	S %A=$S($D(%IS("B")):%IS("B"),1:"HOME") ;Setup default
-	I %IS["P",%A="HOME",$D(^%ZIS(1,%E,99)),$D(^%ZIS(1,+^(99),0)) S %A=$P(^(0),"^",1)
-RD	W !,$S($D(%IS("A")):%IS("A"),1:"DEVICE: ") W:%A]"" %A,"// " D SBR S:%X="" %X=%A S %ZISVT=%X
-	I %X?2"?".E D EN2^%ZIS7 G R
-	I %X?1"?".E D EN1^%ZIS7 G R
-	I $D(DTOUT)!$D(DUOUT)!(%X'?.ANP)!($L($P(%X,";"))>31) S:%IS["T" IO="" S POP=1 Q
-	S:%X'?1.UNP %X=$$UP(%X) D SETQ G R:$T Q
-SETQ	S %Y=$P(%X,";",2,9),%X=$P(%X,";",1) S:$L(";"_%Y,";/")=2 IO("P")=$P(";"_%Y,";/",2)
-	I %IS["Q",%X="Q" S %X=%Y,%ZISVT=$P(%ZISVT,";",2,9),%ZISB=0,IO("Q")=1,%IS("A")="DEVICE: " S:$D(IOP) %Y=$P(%X,";",2,9),%X=$P(%X,";",1)
-	I $T,'$D(IOP) W "UEUE TO PRINT ON" Q  ; Return $T value
-	Q
-LKUP	S %ZISMY=$P(%ZISVT,";",2,999),%ZISVT=$P(%ZISVT,";")
-	I %X="H" W:'$D(IOP) "ome" S %X=0
-	I 0[%X!(%X="HOME")!(%X=$I) S %A=%H Q
-	I $E(%ZISVT)="`",$D(IOP) S %A=+$E(%ZISVT,2,999) I $G(^%ZIS(1,%A,0))]"" Q
-	S %A=0 I "P"[%X Q:$D(IOP)&('$D(^%ZIS(1,%E,99)))  I $D(^%ZIS(1,%E,99)) S %A=+^(99) Q
-	I %X=" ",$D(DUZ)#2,$D(^DISV(+DUZ,"^%ZIS(1,")) S %A=^("^%ZIS(1,") Q
-	S %A=+$O(^%ZIS(1,"B",%ZISVT,0)) Q:%A>0  ;mixed case lookup
-	I %X'=%ZISVT S %A=+$O(^%ZIS(1,"B",%X,0)) Q:%A>0  ;uppercase lookup
-	D VTLKUP^%ZIS S %A=%E Q:%A>0  ;mixed case lookup
-	I %X'=%ZISVT S %ZISVT=%X D VTLKUP^%ZIS S %A=%E Q:%A>0  ;uppercase lookup
-	N %XX,%YY S %XX=%X D 1^%ZIS5 S %A=+%YY Q
-SBR	K DFOUT,DTOUT,DUOUT R %X:$S($D(DTIME)#2:DTIME,1:300) E  W $C(7) S DTOUT=1 Q
-	S:%X="."!(%X="^") DUOUT=1,%X="" Q
-LC	S %X=$$UP(%X)
-	Q
-LOW(%)	Q $TR(%,"ABCDEFGHIJKLMNOPQRSTUVWXYZ","abcdefghijklmnopqrstuvwxyz")
-UP(%)	Q $TR(%,"abcdefghijklmnopqrstuvwxyz","ABCDEFGHIJKLMNOPQRSTUVWXYZ")
-	;
-	;Call/Return % = 1 (yes), 2 (no) -1 (^)
-YN	W "? ",$P("Yes// ^No// ",U,%)
-RYN	R %X:$S($D(DTIME):DTIME,$D(%ZISDTIM):%ZISDTIM,1:300) E  S DTOUT=1,%X=U W $C(7)
-	S:%X]""!'% %=$A(%X),%=$S(%=89:1,%=121:1,%=78:2,%=110:2,%=94:-1,1:0)
-	I '%,%X'?."?" W $C(7),"??",!?4,"ANSWER 'Yes' OR 'No': " G RYN
-	W:$X>73 ! W $P("  (Yes)^  (No)",U,%)
-	Q
-MSG1	I '$D(IOP) W ?20,$C(7),"  [DEVICE DOES NOT EXIST]"
-	Q
-SETVAR	;Come here to setup the variables for the selected device
-	S:$D(IO)[0 IO="" G KILVAR:%IS["T"&(IO="")
-	I $G(%Z)="" S ION="Unknown device",POP=1 G KILVAR
-	S:IO'=IO(0)&($D(DUZ)#2) ^DISV(+DUZ,"^%ZIS(1,")=%E
-	S ION=$P(%Z,"^",1),IOM=+%Z91,IOF=$P(%Z91,"^",2),IOSL=$P(%Z91,"^",3),IOBS=$P(%Z91,"^",4),IOXY=$P(%Z91,"^",5)
-	I IOSL>65530 S IOSL=65530 ;Cache rolls $Y at 65535
-	S IOT=%ZTYPE,IOST(0)=%ZISIOST(0),IOST=%ZISIOST,IOPAR=%ZISOPAR,IOUPAR=%ZISUPAR,IOHG=%ZISHG
-	S:IOF="" IOF="#" ;See that IOF has something
-	K IOCPU S:$D(%ZISCPU) IOCPU=%ZISCPU
-	G KIL
-	;
-KILVAR	;Come here to restore the calling variables
-	D SYMBOL^%ZISUTL(1,"%ZISOLD")
-	S:'$L($G(IOF)) IOF="#" S:'$D(IOST(0)) IOST(0)=0
-	;See that all standard variables are defined
-	F %I="IO","ION","IOM","IOBS","IOSL","IOST" S:$D(@%I)[0 @%I=""
-	K IO("HFSIO"),IO("OPEN") I $D(%ZISCPU) S:'$D(IOCPU) IOCPU=%ZISCPU
-KIL	;Final exit cleanup
-	S:'POP IOS=%ZISIOS I POP K:%IS'["T" %ZISIOS I %IS["T" K IOS S:$D(%ZISIOS) IOS=%ZISIOS
-	S:%IS["T" IO("T")=1 K %ZIS,%IS,%A,%E,%H,%ZISOS,%ZISV,IOP
-K2	K %I,%X,%Y,%Z,%Z1,%Z91,%Z95,%ZTYPE,%ZTIME
-	K %ZISCHK,%ZISCPU,%ZISI,%ZISR,%ZISVT,%ZISB,%ZISX,ZISI,%ZISHGL,%ZISHP,%ZISIO,%ZISIOS,%ZISIOM
-	K %ZISIOF,%ZISIOSL,%ZISIOBS,%ZISIOST,%ZISIOST(0),%ZISTO,%ZISTP,%ZISHG,%ZISSIO,%ZISOPEN,%ZISOPAR,%ZISUPAR
-	K %ZISMY,%ZISQUIT,%ZISLOCK
-	Q
+%ZIS1 ;SFISC/AC,RWF -- DEVICE HANDLER (DEVICE INPUT) ;07/07/2005  15:48
+ ;;8.0;KERNEL;**18,49,69,104,112,199,391**;JUL 10, 1995
+MAIN ;Called from %ZIS with a GO
+ I '$D(IOP),$D(^%ZIS(1,%E,0)),'$P(^(0),"^",3) S %A=%H,%Z=^(0) D L2^%ZIS2 G EXIT
+L1 ;Main Loop
+ I '$D(IOP),$D(IO("Q")),POP D AQUE^%ZIS3 K:%=2 IO("Q") S:%=2 %ZISB=$S(%IS'["N":2,1:0) I %=-1 S POP=1 G EXIT
+ S %E=%H,POP=0,%IS=%ZIS ;Reset %IS from %ZIS
+ I %IS'["Q",$D(XQNOGO) S POP=1 W:'$D(IOP) !,*7,"OUTPUT IS NEVER ALLOWED FOR THIS OPTION" G EXIT
+ D IOP:$D(IOP),R:'$D(IOP)
+ G EXIT:$D(DTOUT)!$D(DUOUT)!(POP&$D(IOP)),L1:POP&'$D(IOP)
+ D LKUP I %A'>0 S POP=1 D:'$D(DUOUT) MSG1 K DUOUT
+ I POP G EXIT:$D(IOP),L1:'$D(IOP)
+ I '$D(^%ZIS(1,%A,0)) D MSG1 K %ZISIOS S POP=1
+ I POP G EXIT:$D(IOP),L1:'$D(IOP)
+ S %E=%A,%Z=^%ZIS(1,%A,0),%Z1=$G(^(1))
+ I $D(%ZIS("S")) N Y S Y=%E D XS^ZISX S:'$T POP=1 G G:POP
+ W:'$D(IOP)&($P(%Z,"^",2)'=$I)&($P(%Z1,"^")]"") "  ",$P(%Z1,"^")
+ D L2^%ZIS2
+G G L1:POP&'$D(IOP)&'($D(DTOUT)!$D(DUOUT)) ;Didn't get it
+ ;For type[TRM reset $X & $Y
+ I 'POP,%ZTYPE["TRM",IO]"",$D(IO(1,IO)) U IO S:'(IO=IO(0)&'$D(IO("S"))&'$D(ZTQUEUED)) $X=0,$Y=0
+ ;
+EXIT I $D(IO)#2,IO]"",$D(IO(1,IO))#2,$D(%Z1),$P(%Z1,"^",11) S IO(1,IO,"NOFF")=1
+ ;Do count of number of times device opened.  Field 51.
+ I $L($G(IO)),$D(IO(1,IO))#2,'POP,$G(%ZISIOS) D
+ . S $P(^(5),"^",1)=$P($G(^%ZIS(1,%ZISIOS,5)),"^",1)+1
+ I 'POP,%ZIS["H" S IO(0)=IO,IO("HOME")=%ZISIOS_"^"_IO ;Make home device
+ I %IS'[0,$G(IO(0))]"" U IO(0) ;Make sure return with home active
+ G SETVAR:'POP!(%IS["T"),KILVAR
+ ;
+IOP ;Request with IOP set
+ S (%ZISVT,%X)=IOP S:%X'?1.UNP %X=$$UP(%X) I %X'="Q" D SETQ Q
+ S %IS=%IS_%X K IOP W %X D SETQ Q
+ ;Get ready to ask user for device
+R I %IS["Q",$D(XQNOGO) W !,*7,"AT THIS TIME, OUTPUT MUST BE QUEUED"
+ S %A=$S($D(%IS("B")):%IS("B"),1:"HOME") ;Setup default
+ I %IS["P",%A="HOME",$D(^%ZIS(1,%E,99)),$D(^%ZIS(1,+^(99),0)) S %A=$P(^(0),"^",1)
+RD W !,$S($D(%IS("A")):%IS("A"),1:"DEVICE: ") W:%A]"" %A,"// " D SBR S:%X="" %X=%A S %ZISVT=%X
+ I %X?2"?".E D EN2^%ZIS7 G R
+ I %X?1"?".E D EN1^%ZIS7 G R
+ I $D(DTOUT)!$D(DUOUT)!(%X'?.ANP)!($L($P(%X,";"))>31) S:%IS["T" IO="" S POP=1 Q
+ S:%X'?1.UNP %X=$$UP(%X) D SETQ G R:$T Q
+SETQ S %Y=$P(%X,";",2,9),%X=$P(%X,";",1) S:$L(";"_%Y,";/")=2 IO("P")=$P(";"_%Y,";/",2)
+ I %IS["Q",%X="Q" S %X=%Y,%ZISVT=$P(%ZISVT,";",2,9),%ZISB=0,IO("Q")=1,%IS("A")="DEVICE: " S:$D(IOP) %Y=$P(%X,";",2,9),%X=$P(%X,";",1)
+ I $T,'$D(IOP) W "UEUE TO PRINT ON" Q  ; Return $T value
+ Q
+LKUP S %ZISMY=$P(%ZISVT,";",2,999),%ZISVT=$P(%ZISVT,";")
+ I %X="H" W:'$D(IOP) "ome" S %X=0
+ I 0[%X!(%X="HOME")!(%X=$I) S %A=%H Q
+ I $E(%ZISVT)="`",$D(IOP) S %A=+$E(%ZISVT,2,999) I $G(^%ZIS(1,%A,0))]"" Q
+ S %A=0 I "P"[%X Q:$D(IOP)&('$D(^%ZIS(1,%E,99)))  I $D(^%ZIS(1,%E,99)) S %A=+^(99) Q
+ I %X=" ",$D(DUZ)#2,$D(^DISV(+DUZ,"^%ZIS(1,")) S %A=^("^%ZIS(1,") Q
+ S %A=+$O(^%ZIS(1,"B",%ZISVT,0)) Q:%A>0  ;mixed case lookup
+ I %X'=%ZISVT S %A=+$O(^%ZIS(1,"B",%X,0)) Q:%A>0  ;uppercase lookup
+ D VTLKUP^%ZIS S %A=%E Q:%A>0  ;mixed case lookup
+ I %X'=%ZISVT S %ZISVT=%X D VTLKUP^%ZIS S %A=%E Q:%A>0  ;uppercase lookup
+ N %XX,%YY S %XX=%X D 1^%ZIS5 S %A=+%YY Q
+SBR K DFOUT,DTOUT,DUOUT R %X:$S($D(DTIME)#2:DTIME,1:300) E  W *7 S DTOUT=1 Q
+ S:%X="."!(%X="^") DUOUT=1,%X="" Q
+LC S %X=$$UP(%X)
+ Q
+LOW(%) Q $TR(%,"ABCDEFGHIJKLMNOPQRSTUVWXYZ","abcdefghijklmnopqrstuvwxyz")
+UP(%) Q $TR(%,"abcdefghijklmnopqrstuvwxyz","ABCDEFGHIJKLMNOPQRSTUVWXYZ")
+YN W "? ",$P("YES// ^NO// ",U,%)
+RYN R %X:$S($D(DTIME):DTIME,$D(%ZISDTIM):%ZISDTIM,1:300) E  S DTOUT=1,%X=U W *7
+ S:%X]""!'% %=$A(%X),%=$S(%=89:1,%=121:1,%=78:2,%=110:2,%=94:-1,1:0)
+ I '%,%X'?."?" W *7,"??",!?4,"ANSWER 'YES' OR 'NO': " G RYN
+ W:$X>73 ! W $P("  (YES)^  (NO)",U,%) Q
+MSG1 I '$D(IOP) W ?20,*7,"  [DEVICE DOES NOT EXIST]"
+ Q
+SETVAR ;Come here to setup the variables for the selected device
+ S:$D(IO)[0 IO="" G KILVAR:%IS["T"&(IO="")
+ I $G(%Z)="" S ION="Unknown device",POP=1 G KILVAR
+ S:IO'=IO(0)&($D(DUZ)#2) ^DISV(+DUZ,"^%ZIS(1,")=%E
+ S ION=$P(%Z,"^",1),IOM=+%Z91,IOF=$P(%Z91,"^",2),IOSL=$P(%Z91,"^",3),IOBS=$P(%Z91,"^",4),IOXY=$P(%Z91,"^",5)
+ I IOSL>65530 S IOSL=65530 ;Cache rolls $Y at 65535
+ S IOT=%ZTYPE,IOST(0)=%ZISIOST(0),IOST=%ZISIOST,IOPAR=%ZISOPAR,IOUPAR=%ZISUPAR,IOHG=%ZISHG
+ S:IOF="" IOF="#" ;See that IOF has something
+ K IOCPU S:$D(%ZISCPU) IOCPU=%ZISCPU G KIL
+ ;
+KILVAR ;Come here to restore the calling variables
+ D SYMBOL^%ZISUTL(1,"%ZISOLD")
+ S:'$L($G(IOF)) IOF="#" S:'$D(IOST(0)) IOST(0)=0
+ ;See that all standard variables are defined
+ F %I="IO","ION","IOM","IOBS","IOSL","IOST" S:$D(@%I)[0 @%I=""
+ K IO("HFSIO"),IO("OPEN") I $D(%ZISCPU) S:'$D(IOCPU) IOCPU=%ZISCPU
+KIL ;Final exit cleanup
+ S:'POP IOS=%ZISIOS I POP K:%IS'["T" %ZISIOS I %IS["T" K IOS S:$D(%ZISIOS) IOS=%ZISIOS
+ S:%IS["T" IO("T")=1 K %ZIS,%IS,%A,%E,%H,%ZISOS,%ZISV,IOP
+K2 K %I,%X,%Y,%Z,%Z1,%Z91,%Z95,%ZTYPE,%ZTIME
+ K %ZISCHK,%ZISCPU,%ZISI,%ZISR,%ZISVT,%ZISB,%ZISX,ZISI,%ZISHGL,%ZISHP,%ZISIO,%ZISIOS,%ZISIOM,%ZISIOF,%ZISIOSL,%ZISIOBS,%ZISIOST,%ZISIOST(0),%ZISTO,%ZISTP,%ZISHG,%ZISSIO,%ZISOPEN,%ZISOPAR,%ZISUPAR
+ K %ZISMY,%ZISQUIT
+ Q
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS2.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS2.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS2.m	(revision 623)
@@ -1,94 +1,90 @@
-%ZIS2	;SFISC/AC,RWF -- DEVICE HANDLER (CHECKS) ;1/24/08  16:07
-	;;8.0;KERNEL;**69,104,112,118,136,241,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-HUNT	S:'$D(%ZISHP) %ZISHP=%E,%ZISHGL=0 S %E=0
-	F  S %ZISHGL=$O(^%ZIS(1,%ZISHG(0),"HG",%ZISHGL)) Q:%ZISHGL'>0  D  Q:%E
-	. N %1,%2 S %1=$G(^%ZIS(1,%ZISHG(0),"HG",+%ZISHGL,0)),%2=$G(^%ZIS(1,+%1,0))
-	. ;Check that HG device is on same VOL.
-	. I $P(%2,"^",9)=%ZISV!($P(%2,"^",9)="") S %E=+$P(^%ZIS(1,%ZISHG(0),"HG",+%ZISHGL,0),"^")
-	. Q
-	G L2:%ZISHGL>0 S %ZISHPOP=1,%E=%ZISHP
-	;
-L2	;Entry point from %ZIS1
-	I $D(DTOUT)!$D(DUOUT) K %ZISHP,%ZISHPOP Q
-CHECK	;Get IO check for secondary $I
-	K %ZISCPU N %Z2
-	S POP=0,%Z=^%ZIS(1,%E,0),%Z2=$S(%ZIS("PRI")=1:"",1:$G(^%ZIS(1,%E,2))) ;Get Primary and secondary IO.
-	S IO=$S(%ZIS("PRI")=1:$P(%Z,"^",2),$L($P(%Z2,"^")):$P(%Z2,"^"),1:$P(%Z,"^",2)) ;
-	S:%IS["Q"&'$D(ZTQUEUED)&($P(%Z,"^",12)=1!$D(XQNOGO)) %ZISB=0,IO("Q")=1 ;Forced Queueing
-	I $P(%Z,"^",12)=2 S %IS=$TR(%IS,"Q") I $D(IO("Q")) D  Q
-	. I '$D(IOP) W !,"Queuing NOT ALLOWED on this device"
-	. S POP=1 K:$D(IOP) IO("Q") Q
-	S %Z90=$G(^(90)),%Z95=$G(^(95)),%ZTIME=$G(^("TIME")),%ZTYPE=$G(^("TYPE")),%ZISHG=$O(^%ZIS(1,"AHG",%E,0))
-	I %ZISHG,$D(^%ZIS(1,+%ZISHG,0)) S:'$D(%ZISHG(0)) %ZISHG(0)=+%ZISHG S %ZISHG=$P(^(0),"^",1)
-	E  S %ZISHG=""
-	I %ZTYPE="HG" D OTHCPU("HUNT GROUP") G T:$D(%ZISHG(0))!POP
-	I %ZTYPE="RES" S %ZISRL=+$P(%Z1,"^",10) G T
-VTRM	I %ZTYPE="VTRM",'('$D(IO("Q"))&(%A=%H)) W:'$D(IOP)&'$D(%ZISHP) *7,"  [YOU CAN NOT SELECT A VIRTUAL TERMINAL]" S POP=1 ;Virtual Terminal Check
-	S:%ZTYPE="VTRM"&'$D(IO("Q"))&(%A=%H) IO=$I
-	;
-SLAVE	I $D(IO("Q")),$P(%Z,"^",2)=0,$P(%Z,"^",8)']"" W:'$D(IOP) *7,!?10,"  [SLAVE device NOT set up for queuing]" S POP=1 G T
-OCPU	D OTHCPU("DEVICE")
-	;
-OOS	G T:POP I %Z90,$D(DT)#2,%Z90'>DT S POP=1 ;Out Of Service Check
-	I $T,'$D(IOP),'$D(%ZISHP) W *7,"  [Out of Service]" ;I 'POP W " ..OK" S %=2,U="^" D YN^%ZIS1 G:%=0 OOS S:%'=1 POP=1
-	;
-PTIME	G T:POP!(IO=$I)!(IO=0)
-	;Prohibitted Time Check
-	S %A=$P(%ZTIME,"^") I %ZISB,$L(%A) D  I POP,'$D(IOP),'$D(%ZISHP) W *7,"  [ACCESS PROHIBITED "_%A_"]" ;AT THIS TIME]"
-	. N %C,%L,%H ;%C is current time, %L is lower limit, %H is upper limit
-	. S %C=$P($H,",",2),%C=%C\60#60+(%C\3600*100),%H=$P(%A,"-",2),%L=+%A
-	. I $S(%H'<%L:(%C'>%H&(%C'<%L)),1:(%C'<%L!(%C'>%H))) S POP=1
-	. Q
-DUZ	I 'POP D SEC ;Security Check
-	;
-T	I POP,$D(%ZISHG(0)),%IS'["D",'$D(%ZISHPOP),%ZISB G HUNT
-	I POP D HGBSY:$D(%ZISHPOP) ;G T2:%IS["T"
-	;
-TMPVAR	K IO("S") S %ZISIOS=%E S:IO=0 IO=$I,IO("S")=%H
-	S %ZISOPAR=$$IOPAR(%E,"IOPAR")
-	S %ZISUPAR=$$IOPAR(%E,"IOUPAR"),%ZISTO=+$P(%ZTIME,"^",2)
-	I $D(IO("S")) D  I POP Q
-	. S IO=$S(%IS["S":$P($G(^%ZIS(1,+$P(%Z,"^",8),0)),"^",2),1:IO)
-	. I %IS["S",IO]"" S %H=+$P(%Z,"^",8),IO("S")=%H,IO(0)=IO
-	. S IO("S")=$S($G(^XUTL("XQ",$J,"IOST(0)")):^("IOST(0)"),1:$G(^%ZIS(1,%H,"SUBTYPE")))
-	. S:IO="" POP=1
-	. Q
-	S %A=+$G(^%ZIS(1,%E,"SUBTYPE")),%ZISTP=0 ;%A is pointer to subtype
-	I %E=%H,%ZTYPE["TRM" D  I 1
-	. I $D(^XUTL("XQ",$J,"IOST(0)")) D  ;Use home
-	. . S %A=+^XUTL("XQ",$J,"IOST(0)"),%Z91="",%ZISTP=1
-	. . F %ZISI="IOM","IOF","IOSL","IOBS","IOXY" S %Z91=%Z91_$G(^XUTL("XQ",$J,%ZISI))_"^"
-	. E  S %=$$LNPRTSUB^%ZISUTL I %>0 S %A=%,%Z91=""
-	E  S %Z91=$P($G(^%ZIS(2,%A,1)),"^",1,4),$P(%Z91,"^",5)=$G(^("XY"))
-	;I $D(%Z91),%Z91'?1.4"^" ;$P(%Z91,"^")]"",$P(%Z91,"^",2)]"",$P(%Z91,"^",3),$P(%Z91,"^",4)]""
-	D ST^%ZIS3(%ZISTP) S:%IS["U" USIO=$P(%Z91,"^",1,4)
-T2	I POP S:%IS'["T" IO="" Q
-	G ^%ZIS3:"^MTRM^VTRM^TRM^SPL^MT^SDP^HFS^RES^OTH^BAR^HG^IMPC^CHAN^"[("^"_%ZTYPE_"^") ;Jump to next part
-	S POP=1 Q
-	;
-HGBSY	S POP=1 S:%IS'["T" IO="" K %ZISHP,%ZISHPOP Q:$D(IOP)
-	W:$X>38 !,?5 W *7," All devices in hunt group "_%ZISHG_" are busy!" Q
-	;
-OTHCPU(%1)	;%1 should be either DEVICE or HUNT GROUP
-	N %2,X,Y,%ZISMSG S %ZISMSG=0
-	F %2="CPU","VOLUME SET" D
-	.I %2="VOLUME SET" S X=$P($P(%Z,"^",9),":"),Y=%ZISV
-	.E  D GETENV^%ZOSV S X=$P($P(%Z,"^",9),":",2),Y=$P($P(Y,"^",4),":",2)
-	.I X=Y!(X="") Q:%1="DEVICE"  D  Q  ;Other Vol Set/Cpu Check
-	..S %ZISHG(0)=%E,%ZISHG=$P(%Z,"^")
-	..I %ZISB S POP=1
-	..E  S IO=" "
-	.I %2="VOLUME SET" S $P(%ZISCPU,":")=X
-	.E  S $P(%ZISCPU,":",2)=X
-	.I %1="HUNT GROUP" K %ZISHG(0)
-	.I %IS["Q" S IO("Q")=1,%ZISB=0 S:%1="HUNT GROUP" IO=" "
-	.E  I %ZISB&(%ZTYPE="TRM"&($D(%ZISHG(0))&(%IS'["D"))) S POP=1
-	.E  W:'$D(IOP)&'%ZISMSG *7,"  ["_%1_" is on another "_%2_" ('"_X_"')]",! S POP=1,%ZISMSG=1
-	Q
-IOPAR(%DA,%N)	;Return I/O parameters
-	Q $S($G(%ZIS(%N))]"":%ZIS(%N),1:$G(^%ZIS(1,%DA,%N)))
-	;
-SEC	I %Z95]"" S %X=$G(DUZ(0)) I %X'="@" S POP=1 F %A=1:1:$L(%X) I %Z95[$E(%X,%A) S POP=0 Q
-	I POP,'$D(IOP),'$D(%ZISHP) W *7,"  [Access Prohibited]"
-	Q
+%ZIS2 ;SFISC/AC,RWF -- DEVICE HANDLER (CHECKS) ;06/12/2002  15:41
+ ;;8.0;KERNEL;**69,104,112,118,136,241**;JUL 10, 1995
+HUNT S:'$D(%ZISHP) %ZISHP=%E,%ZISHGL=0 S %E=0
+ F  S %ZISHGL=$O(^%ZIS(1,%ZISHG(0),"HG",%ZISHGL)) Q:%ZISHGL'>0  D  Q:%E
+ . N %1,%2 S %1=$G(^%ZIS(1,%ZISHG(0),"HG",+%ZISHGL,0)),%2=$G(^%ZIS(1,+%1,0))
+ . ;Check that HG device is on same VOL.
+ . I $P(%2,"^",9)=%ZISV!($P(%2,"^",9)="") S %E=+$P(^%ZIS(1,%ZISHG(0),"HG",+%ZISHGL,0),"^")
+ . Q
+ G L2:%ZISHGL>0 S %ZISHPOP=1,%E=%ZISHP
+ ;
+L2 ;Entry point from %ZIS1
+ I $D(DTOUT)!$D(DUOUT) K %ZISHP,%ZISHPOP Q
+CHECK K %ZISCPU S POP=0,%Z=^%ZIS(1,%E,0),IO=$P(%Z,"^",2)
+ S:%IS["Q"&'$D(ZTQUEUED)&($P(%Z,"^",12)=1!$D(XQNOGO)) %ZISB=0,IO("Q")=1 ;Forced Queueing 
+ I $P(%Z,"^",12)=2 S %IS=$TR(%IS,"Q") I $D(IO("Q")) D  Q
+ . I '$D(IOP) W !,"Queuing NOT ALLOWED on this device"
+ . S POP=1 K:$D(IOP) IO("Q") Q
+ S %Z90=$G(^(90)),%Z95=$G(^(95)),%ZTIME=$G(^("TIME")),%ZTYPE=$G(^("TYPE")),%ZISHG=$O(^%ZIS(1,"AHG",%E,0))
+ I %ZISHG,$D(^%ZIS(1,+%ZISHG,0)) S:'$D(%ZISHG(0)) %ZISHG(0)=+%ZISHG S %ZISHG=$P(^(0),"^",1)
+ E  S %ZISHG=""
+ I %ZTYPE="HG" D OTHCPU("HUNT GROUP") G T:$D(%ZISHG(0))!POP
+ I %ZTYPE="RES" S %ZISRL=+$P(%Z1,"^",10) G T
+VTRM I %ZTYPE="VTRM",'('$D(IO("Q"))&(%A=%H)) W:'$D(IOP)&'$D(%ZISHP) *7,"  [YOU CAN NOT SELECT A VIRTUAL TERMINAL]" S POP=1 ;Virtual Terminal Check
+ S:%ZTYPE="VTRM"&'$D(IO("Q"))&(%A=%H) IO=$I
+ ;
+SLAVE I $D(IO("Q")),$P(%Z,"^",2)=0,$P(%Z,"^",8)']"" W:'$D(IOP) *7,!?10,"  [SLAVE device NOT set up for queuing]" S POP=1 G T
+OCPU D OTHCPU("DEVICE")
+ ;
+OOS G T:POP I %Z90,$D(DT)#2,%Z90'>DT S POP=1 ;Out Of Service Check
+ I $T,'$D(IOP),'$D(%ZISHP) W *7,"  [Out of Service]" ;I 'POP W " ..OK" S %=2,U="^" D YN^%ZIS1 G:%=0 OOS S:%'=1 POP=1
+ ;
+PTIME G T:POP!(IO=$I)!(IO=0)
+ ;Prohibitted Time Check
+ S %A=$P(%ZTIME,"^") I %ZISB,$L(%A) D  I POP,'$D(IOP),'$D(%ZISHP) W *7,"  [ACCESS PROHIBITED "_%A_"]" ;AT THIS TIME]"
+ . N %C,%L,%H ;%C is current time, %L is lower limit, %H is upper limit
+ . S %C=$P($H,",",2),%C=%C\60#60+(%C\3600*100),%H=$P(%A,"-",2),%L=+%A
+ . I $S(%H'<%L:(%C'>%H&(%C'<%L)),1:(%C'<%L!(%C'>%H))) S POP=1
+ . Q
+DUZ I 'POP D SEC ;Security Check
+ ;
+T I POP,$D(%ZISHG(0)),%IS'["D",'$D(%ZISHPOP),%ZISB G HUNT
+ I POP D HGBSY:$D(%ZISHPOP) ;G T2:%IS["T"
+ ;
+TMPVAR K IO("S") S %ZISIOS=%E S:IO=0 IO=$I,IO("S")=%H
+ S %ZISOPAR=$$IOPAR(%E,"IOPAR")
+ S %ZISUPAR=$$IOPAR(%E,"IOUPAR"),%ZISTO=+$P(%ZTIME,"^",2)
+ I $D(IO("S")) D  I POP Q
+ . S IO=$S(%IS["S":$P($G(^%ZIS(1,+$P(%Z,"^",8),0)),"^",2),1:IO)
+ . I %IS["S",IO]"" S %H=+$P(%Z,"^",8),IO("S")=%H,IO(0)=IO
+ . S IO("S")=$S($G(^XUTL("XQ",$J,"IOST(0)")):^("IOST(0)"),1:$G(^%ZIS(1,%H,"SUBTYPE")))
+ . S:IO="" POP=1
+ . Q
+ S %A=+$G(^%ZIS(1,%E,"SUBTYPE")),%ZISTP=0 ;%A is pointer to subtype
+ I %E=%H,%ZTYPE["TRM" D  I 1
+ . I $D(^XUTL("XQ",$J,"IOST(0)")) D  ;Use home
+ . . S %A=+^XUTL("XQ",$J,"IOST(0)"),%Z91="",%ZISTP=1
+ . . F %ZISI="IOM","IOF","IOSL","IOBS","IOXY" S %Z91=%Z91_$G(^XUTL("XQ",$J,%ZISI))_"^"
+ . E  S %=$$LNPRTSUB^%ZISUTL I %>0 S %A=%,%Z91=""
+ E  S %Z91=$P($G(^%ZIS(2,%A,1)),"^",1,4),$P(%Z91,"^",5)=$G(^("XY"))
+ ;I $D(%Z91),%Z91'?1.4"^" ;$P(%Z91,"^")]"",$P(%Z91,"^",2)]"",$P(%Z91,"^",3),$P(%Z91,"^",4)]""
+ D ST^%ZIS3(%ZISTP) S:%IS["U" USIO=$P(%Z91,"^",1,4)
+T2 I POP S:%IS'["T" IO="" Q
+ G ^%ZIS3:"^MTRM^VTRM^TRM^SPL^MT^SDP^HFS^RES^OTH^BAR^HG^IMPC^CHAN^"[("^"_%ZTYPE_"^") ;Jump to next part
+ S POP=1 Q
+ ;
+HGBSY S POP=1 S:%IS'["T" IO="" K %ZISHP,%ZISHPOP Q:$D(IOP)
+ W:$X>38 !,?5 W *7," All devices in hunt group "_%ZISHG_" are busy!" Q
+ ;
+OTHCPU(%1) ;%1 should be either DEVICE or HUNT GROUP
+ N %2,X,Y,%ZISMSG S %ZISMSG=0
+ F %2="CPU","VOLUME SET" D
+ .I %2="VOLUME SET" S X=$P($P(%Z,"^",9),":"),Y=%ZISV
+ .E  D GETENV^%ZOSV S X=$P($P(%Z,"^",9),":",2),Y=$P($P(Y,"^",4),":",2)
+ .I X=Y!(X="") Q:%1="DEVICE"  D  Q  ;Other Vol Set/Cpu Check
+ ..S %ZISHG(0)=%E,%ZISHG=$P(%Z,"^")
+ ..I %ZISB S POP=1
+ ..E  S IO=" "
+ .I %2="VOLUME SET" S $P(%ZISCPU,":")=X
+ .E  S $P(%ZISCPU,":",2)=X
+ .I %1="HUNT GROUP" K %ZISHG(0)
+ .I %IS["Q" S IO("Q")=1,%ZISB=0 S:%1="HUNT GROUP" IO=" "
+ .E  I %ZISB&(%ZTYPE="TRM"&($D(%ZISHG(0))&(%IS'["D"))) S POP=1
+ .E  W:'$D(IOP)&'%ZISMSG *7,"  ["_%1_" is on another "_%2_" ('"_X_"')]",! S POP=1,%ZISMSG=1
+ Q
+IOPAR(%DA,%N) ;Return I/O parameters
+ Q $S($G(%ZIS(%N))]"":%ZIS(%N),1:$G(^%ZIS(1,%DA,%N)))
+ ;
+SEC I %Z95]"" S %X=$G(DUZ(0)) I %X'="@" S POP=1 F %A=1:1:$L(%X) I %Z95[$E(%X,%A) S POP=0 Q
+ I POP,'$D(IOP),'$D(%ZISHP) W *7,"  [Access Prohibited]"
+ Q
